'' PropCOMM V2.0b By Jeff Ledger
'' A simple terminal program which communicates to the PC by way of the prop-plug (30,31)
''
'' PropCOMM is set for 9600,N,8,1


CON

   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000

   keyboard  = 26                      ' Keyboard input
   video     = 12                      ' Video output
   serXmit   = 30                      ' Serial Transmit
   serRecv   = 31                      ' Serial Receive

  BLACK             = $02
  GREY              = $03
  LWHITE            = $06
  BWHITE            = $07
  LMAGENTA          = $A3
  WHITE             = $AF
  RED               = $A2
  LRED              = $1A
  LPURPLE           = $1B
  PURPLE            = $03
  LGREEN            = $1C
  SKYBLUE           = $1D
  YELLOW            = $1E
  BYELLOW           = $A6
  LGREY             = $1F
  DGREY             = $08
  GREEN             = $A4
  ORANGE            = $06
  BLUE              = $A1
  CYAN              = $1C
  MAGENTA           = $FC
  LYELLOW           = $1E

  CR                = $0D
  LF                = $0A
  TAB               = $09
  BKS               = $08

  bspKey            = $C8
  escape            = $CB
  backspace         = 8
  fReturn           = 13
  fLinefeed         = 10
  fEof              = -1



OBJ

  text  : "aigeneric_driver"
  key   : "comboKeyboard"             ' Keyboard Driver
  ser   : "FullDuplexSerial"          ' Full Duplex Serial Controller

PUB start | i, a, b, TimeCnt

  key.start(keyboard)                           ' Start keyboard driver
  text.start(video)                             ' Start terminal screen
  ser.start(serRecv,serXmit,%0000,9600)         ' Control link via prop-plug

  titlescreen

  repeat
    terminal

PRI terminal | local,remote,duplex

   duplex := 0
   repeat
      local := key.key
      if local <> 0
         if duplex == 1
            text.out(local)
         'text.dec(local) 'Used to troubleshoot local input
         if local == 208
            local := 13
            titlescreen

         if local == 209
            duplex := 1
            local := 13
            text.str(string("HALF DUPLEX",13))

         if local == 210
            duplex := 0
            local := 13
            text.str(string("FULL DUPLEX",13))

         ser.tx(local)
         if local == 13
           ser.tx(13)


         if local == bspKey
           ser.str(string(8," ",8,8))
             if duplex == 1  'Display Backspace in Half Duplex mode
                 text.str(string(backspace," ",backspace,backspace))

      '## Deal with remote data if present ##

      remote := ser.rxtime(20)
      if remote == 8
         text.str(string(backspace," ",backspace))
         remote := 0

      if remote > 10
           'text.dec(remote) 'Used to troubleshoot remote input
           text.out(remote)

PUB titlescreen

  text.cls
  text.str(string(13,"    PropCOMM ASCII V2.0b: By Jeff Ledger    ",13,13))

  text.color(blue)
  text.str(string(" ["))
  text.color(white)
  text.str(string("F1"))
  text.color(blue)
  text.str(string("] "))
  text.color(white)
  text.str(string("Reset Terminal Window",13))
  text.color(blue)
  text.str(string(" ["))
  text.color(white)
  text.str(string("F2"))
  text.color(blue)
  text.str(string("] "))
  text.color(white)
  text.str(string("Set Terminal to Half Duplex",13))
  text.color(blue)
  text.str(string(" ["))
  text.color(white)
  text.str(string("F3"))
  text.color(blue)
  text.str(string("] "))
  text.color(white)
  text.str(string("Set Terminal to Full Duplex",13))
  text.str(string(" 9600,N,8,1: Terminal Ready.",13,":"))

